%global avahi_version 0.6
%global fuse_version 3.0.0
%global glib2_version 2.70.0
%global gsettings_desktop_schemas_version 3.33.0
%global goa_version 3.17.1
%global gudev_version 147
%global libarchive_version 3.0.22
%global libcdio_paranoia_version 0.78.2
%global libgcrypt_version 1.2.2
%global libgdata_version 0.18.0
%global libgphoto2_version 2.5.0
%global libimobiledevice_version 1.2
%global libmtp_version 1.1.15
%global libnfs_version 1.9.8
%global libplist_version 2.2
%global libsmbclient_version 4.12.0
%global libsoup_version 3.0.0
%global libusb_version 1.0.21
%global systemd_version 206
%global talloc_version 1.3.0
%global udisks2_version 1.97

%global url_ver %%(echo %{version} | cut -d. -f1-2)

Summary: Backends for the gio framework in GLib
Name: gvfs
Version: 1.51.90
Release: 2%{?dist}
License: GPLv3 and LGPLv2+ and BSD and MPLv2.0
URL:     https://wiki.gnome.org/Projects/gvfs
Source0: https://download.gnome.org/sources/gvfs/%{url_ver}/gvfs-%{version}.tar.xz

BuildRequires: meson gcc
BuildRequires: pkgconfig(glib-2.0) >= %{glib2_version}
BuildRequires: pkgconfig(dbus-1) pkgconfig(gcr-3) pkgconfig(libsecret-1) /usr/bin/ssh
BuildRequires: pkgconfig(gsettings-desktop-schemas) >= %{gsettings_desktop_schemas_version}
BuildRequires: pkgconfig(libcdio_paranoia) >= %{libcdio_paranoia_version}
BuildRequires: pkgconfig(gudev-1.0) >= %{gudev_version}
BuildRequires: pkgconfig(libsoup-3.0) >= %{libsoup_version}
BuildRequires: pkgconfig(avahi-client) >= %{avahi_version}
BuildRequires: pkgconfig(avahi-glib) >= %{avahi_version}
BuildRequires: pkgconfig(udisks2) >= %{udisks2_version}
BuildRequires: gettext-devel pkgconfig(libxslt) docbook-style-xsl
BuildRequires: systemd-devel >= %{systemd_version} pkgconfig(polkit-gobject-1) pkgconfig(libcap)
Requires: %{name}-client = %{version}-%{release}
Requires: glib2 >= %{glib2_version} polkit udisks2 >= %{udisks2_version}
Requires: gsettings-desktop-schemas >= %{gsettings_desktop_schemas_version}


%description
This package provides backend implementations for the gio framework in GLib, including ftp, 
sftp, cifs.


%package  client
Summary:  Client modules of backends for the gio framework in GLib

%description client
This package provides client modules of backend implementations for the gio framework in GLib.


%package devel
Summary: Development files for gvfs
Requires: %{name}-client = %{version}-%{release}

%description devel
This package provides headers and other files that are required to develop applications using 
gvfs.


%package fuse
Summary: FUSE support for gvfs
BuildRequires: pkgconfig(fuse3) >= %{fuse_version}
Requires: %{name} = %{version}-%{release}
Requires: %{name}-client = %{version}-%{release}
Requires: fuse3 >= %{fuse_version}

%description fuse
This package provides support for applications not using gio to access the gvfs filesystems.


%package smb
Summary: Windows fileshare support for gvfs
BuildRequires: libsmbclient-devel >= %{libsmbclient_version}
BuildRequires: pkgconfig(talloc) >= %{talloc_version}
Requires: %{name} = %{version}-%{release}
Requires: %{name}-client = %{version}-%{release}

%description smb
This package provides support for reading and writing files on windows shares (SMB) to 
applications using gvfs.


%package gphoto2
Summary: gphoto2 support for gvfs
BuildRequires: pkgconfig(libgphoto2) >= %{libgphoto2_version}
BuildRequires: libexif-devel
Requires: %{name} = %{version}-%{release}
Requires: %{name}-client = %{version}-%{release}

%description gphoto2
This package provides support for reading and writing files on PTP based cameras (Picture 
Transfer Protocol) and MTP based media players (Media Transfer Protocol) to applications 
using gvfs.


%package mtp
Summary: MTP support for gvfs
BuildRequires: pkgconfig(libmtp) >= %{libmtp_version}
BuildRequires: pkgconfig(libusb-1.0) >= %{libusb_version}
Requires: %{name} = %{version}-%{release}
Requires: %{name}-client = %{version}-%{release}

%description mtp
This package provides support for reading and writing files on MTP based devices (Media 
Transfer Protocol) to applications using gvfs.


%package goa
Summary: GOA support for gvfs
BuildRequires: pkgconfig(goa-1.0) >= %{goa_version}
BuildRequires: pkgconfig(libgdata) >= %{libgdata_version}
Requires: %{name} = %{version}-%{release}
Requires: %{name}-client = %{version}-%{release}
Requires: libgdata >= %{libgdata_version}

%description goa
This package provides seamless integration with gnome-online-accounts file services.


%package  tests
Summary:  Tests for the gvfs package
Requires: %{name} = %{version}-%{release}

%description tests
This package provides tests that can be used to verify the functionality of the installed 
gvfs package.


%prep
%autosetup -p1

%build
%meson -Dinstalled_tests=true \
       -Dman=true \
       -Dnfs=false \
       -Dbluray=false \
       -Dafc=false \
       -Darchive=false \
       -Dafp=false \
       -Dgcrypt=false \
        %{nil}
%meson_build

%install
%meson_install

cp -p daemon/trashlib/COPYING COPYING.GPL3

%find_lang gvfs

%post
# reload the .mount files:
killall -USR1 gvfsd >&/dev/null || :

# reload the .mount files when single subpackage is installed:
%post smb
killall -USR1 gvfsd >&/dev/null || :
%post gphoto2
killall -USR1 gvfsd >&/dev/null || :
%post mtp
killall -USR1 gvfsd >&/dev/null || :
%post goa
killall -USR1 gvfsd >&/dev/null || :


%files
%{_libdir}/gvfs/libgvfsdaemon.so
%{_libexecdir}/gvfsd
%{_libexecdir}/gvfsd-admin
%{_libexecdir}/gvfsd-ftp
%{_libexecdir}/gvfsd-sftp
%{_libexecdir}/gvfsd-trash
%{_libexecdir}/gvfsd-cdda
%{_libexecdir}/gvfsd-computer
%{_libexecdir}/gvfsd-dav
%{_libexecdir}/gvfsd-http
%{_libexecdir}/gvfsd-localtest
%{_libexecdir}/gvfsd-burn
%{_libexecdir}/gvfsd-dnssd
%{_libexecdir}/gvfsd-network
%{_libexecdir}/gvfsd-metadata
%{_libexecdir}/gvfs-udisks2-volume-monitor
%{_libexecdir}/gvfsd-recent
%{_userunitdir}/gvfs-daemon.service
%{_userunitdir}/gvfs-metadata.service
%{_userunitdir}/gvfs-udisks2-volume-monitor.service
%dir %{_datadir}/gvfs
%dir %{_datadir}/gvfs/mounts
%dir %{_datadir}/gvfs/remote-volume-monitors
%{_datadir}/gvfs/mounts/admin.mount
%{_datadir}/gvfs/mounts/sftp.mount
%{_datadir}/gvfs/mounts/trash.mount
%{_datadir}/gvfs/mounts/cdda.mount
%{_datadir}/gvfs/mounts/computer.mount
%{_datadir}/gvfs/mounts/dav.mount
%{_datadir}/gvfs/mounts/dav+sd.mount
%{_datadir}/gvfs/mounts/http.mount
%{_datadir}/gvfs/mounts/localtest.mount
%{_datadir}/gvfs/mounts/burn.mount
%{_datadir}/gvfs/mounts/dns-sd.mount
%{_datadir}/gvfs/mounts/network.mount
%{_datadir}/gvfs/mounts/ftp.mount
%{_datadir}/gvfs/mounts/ftpis.mount
%{_datadir}/gvfs/mounts/ftps.mount
%{_datadir}/gvfs/mounts/recent.mount
%{_datadir}/dbus-1/services/org.gtk.vfs.Daemon.service
%{_datadir}/dbus-1/services/org.gtk.vfs.Metadata.service
%{_datadir}/dbus-1/services/org.gtk.vfs.UDisks2VolumeMonitor.service
%{_datadir}/gvfs/remote-volume-monitors/udisks2.monitor
%{_datadir}/GConf/gsettings/*.convert
%{_datadir}/glib-2.0/schemas/*.xml
%{_datadir}/polkit-1/actions/org.gtk.vfs.file-operations.policy
%{_datadir}/polkit-1/rules.d/org.gtk.vfs.file-operations.rules
%{_mandir}/man1/gvfsd.1*
%{_mandir}/man1/gvfsd-metadata.1*


%files client -f gvfs.lang
%license COPYING COPYING.GPL3
%doc NEWS README.md
%dir %{_libdir}/gvfs
%{_libdir}/gvfs/libgvfscommon.so
%{_libdir}/gio/modules/libgioremote-volume-monitor.so
%{_libdir}/gio/modules/libgvfsdbus.so
%{_mandir}/man7/gvfs.7*


%files devel
%dir %{_includedir}/gvfs-client
%dir %{_includedir}/gvfs-client/gvfs
%{_includedir}/gvfs-client/gvfs/gvfsurimapper.h
%{_includedir}/gvfs-client/gvfs/gvfsuriutils.h


%files fuse
%{_tmpfilesdir}/gvfsd-fuse-tmpfiles.conf
%{_libexecdir}/gvfsd-fuse
%{_mandir}/man1/gvfsd-fuse.1*


%files smb
%{_libexecdir}/gvfsd-smb
%{_libexecdir}/gvfsd-smb-browse
%{_datadir}/gvfs/mounts/smb-browse.mount
%{_datadir}/gvfs/mounts/smb.mount


%files gphoto2
%{_libexecdir}/gvfsd-gphoto2
%{_libexecdir}/gvfs-gphoto2-volume-monitor
%{_userunitdir}/gvfs-gphoto2-volume-monitor.service
%{_datadir}/gvfs/mounts/gphoto2.mount
%{_datadir}/dbus-1/services/org.gtk.vfs.GPhoto2VolumeMonitor.service
%{_datadir}/gvfs/remote-volume-monitors/gphoto2.monitor

%files mtp
%{_libexecdir}/gvfsd-mtp
%{_libexecdir}/gvfs-mtp-volume-monitor
%{_userunitdir}/gvfs-mtp-volume-monitor.service
%{_datadir}/gvfs/mounts/mtp.mount
%{_datadir}/dbus-1/services/org.gtk.vfs.MTPVolumeMonitor.service
%{_datadir}/gvfs/remote-volume-monitors/mtp.monitor


%files goa
%{_libexecdir}/gvfs-goa-volume-monitor
%{_libexecdir}/gvfsd-google
%{_userunitdir}/gvfs-goa-volume-monitor.service
%{_datadir}/dbus-1/services/org.gtk.vfs.GoaVolumeMonitor.service
%{_datadir}/gvfs/remote-volume-monitors/goa.monitor
%{_datadir}/gvfs/mounts/google.mount


%files tests
%dir %{_libexecdir}/installed-tests
%{_libexecdir}/installed-tests/gvfs
%{_datadir}/installed-tests


%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.51.90-2
- Rebuilt for OpenCloudOS Stream 23.09

* Wed Aug 23 2023 Shuo Wang <abushwang@tencent.com> - 1.51.90-1
- update to 1.51.90

* Wed Aug 23 2023 Wang Guodong <gordonwwang@tencent.com> - 1.50.2-6
- Rebuilt for udisks2 2.10.0

* Thu Aug 17 2023 cunshunxia <cunshunxia@tencent.com> - 1.50.2-5
- Rebuilt for samba 4.18.5

* Thu Jul 20 2023 cunshunxia <cunshunxia@tencent.com> - 1.50.2-4
- Rebuilt for samba 4.18.4

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.50.2-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.50.2-2
- Rebuilt for OpenCloudOS Stream 23

* Wed Dec 21 2022 Wang Guodong <gordonwwang@tencent.com> - 1.50.2-1
- package init.
